#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>
#include <ctype.h>
#include <termios.h>
#include <sys/types.h>
#include <sys/mman.h>

#define MAP_SIZE 4096UL
#define MAP_MASK (MAP_SIZE - 1)

main(int iArg, char **szArg)
{
	void *test_map_base, *test_virt_base;
	volatile int *ptr, nval;
	int fd;

	off_t TargetAddr;
	sscanf(szArg[1], "0x%X", &TargetAddr);
	sscanf(szArg[2], "0x%X", &nval);
	fd = open("/dev/mem", O_RDWR | O_SYNC);
	test_map_base =
	    mmap(0, MAP_SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, fd,
		 TargetAddr & ~MAP_MASK);
	test_virt_base = test_map_base + (TargetAddr & MAP_MASK);
	printf("virtual base at %p (phys=0x%X)\n", test_virt_base, TargetAddr);

	ptr = test_virt_base;
	*ptr = nval;
	munmap(test_map_base, MAP_SIZE);
	return 0;
}

####### reading


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/mman.h>

#define MAP_SIZE 4096UL
#define MAP_MASK (MAP_SIZE - 1)

static struct map_pair {
	int virt;
	int phys;
	char *name;
} interesting[] = {
	{
	0xbc0f0000, 0x1f00000, "smem"}, {
	0xba080000, 0x80000, "spinlock"}, {
	0xba800000, 0x800000, "qcsbl"}, {
	0xba900000, 0x900000, "oemsbl"}, {
	0xbaa00000, 0xa00000, "l4 stuff?"}
};

main(int iArg, char **szArg)
{
	void *test_map_base, *test_virt_base;
	volatile short *ptr, nval;
	int fd, i;

	for (i = 0; i < sizeof(interesting) / sizeof(interesting[0]); i++) {
		fd = open("/dev/mem", O_RDWR | O_SYNC);
		test_map_base =
		    mmap(interesting[i].virt,
			 MAP_SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, fd,
			 interesting[i].phys);
		test_virt_base =
		    test_map_base + (interesting[i].phys & MAP_MASK);
		ptr = test_virt_base;
		printf("V=%08x, P=%08x", interesting[i].virt,
		       interesting[i].phys);
		printf(" val=%08x\n", *ptr);
		munmap(test_map_base, MAP_SIZE);
		close(fd);
	}
	return 0;
}
